#ifndef _crglist_
#define _crglist_

#ifndef NULL
#define NULL 0
#endif

/* ---------------------
 * List processing stuff
 * --------------------- */

typedef struct _list {
    void *head;
    struct _list *tail;
} LIST_ITEM;

typedef LIST_ITEM *LIST;

#define NIL list_initialize()

#define foreach(C,T,L) \
{ \
	C *T; \
	LIST list_temp; \
	for (list_temp=L,T=(list_temp->tail == (void *)NULL) ? (C *)NULL : (C *)(list_temp->head); \
		 (list_temp!=NULL)&&(list_temp->tail!=(void *)NULL); \
		 list_temp=list_temp->tail,T=(list_temp->tail == (void *)NULL) ? (C *)NULL : (C *)(list_temp->head))

#define endforeach \
}

/* -----------------------------------
 * List processing function prototypes
 * ----------------------------------- */

LIST list_initialize();
void list_append(void *item, LIST list);
void list_prepend(void *item, LIST list);
LIST list_copy(LIST list);
LIST list_reverse(LIST list);
void list_union(void *item, LIST list);
LIST list_list(void *item);
int list_empty(LIST list);
int list_member(void *item, LIST list);
void *list_first(LIST list);
LIST list_rest(LIST list);
void *list_remove(void *item, LIST list);
void *list_remove_first(LIST list);
void *list_first(LIST list);
int list_length(LIST list);
void list_free(LIST list);
LIST list_intersection(LIST a, LIST b);

/* #include "gmalloc.h" */

#endif /* _crglist_ */
