/* ========================================================================
 * CRG include
 * ======================================================================== */

#ifndef _crgtype_
#define _crgtype_

typedef struct _unary {
	struct _part *part;
	int view;
	int class;
	float *value;
} UNARY;

typedef struct _binary {
	struct _part *part1;
	struct _part *part2;
	int view;
	int class;
	float *value;
} BINARY;

typedef struct _part {
	int name;
	int view;
	int class;
	struct _unary *unary;
	LIST binary;					/* list of BINARY */
} PART;

typedef struct _rule {
	int nfeatures;
	int *important;					/* features used for discrimination */
	float *lower;
	float *upper;
} RULE;

typedef struct _path {
	int length;
    struct _part **part;
	struct _unary **unary;
	struct _binary **binary;
} PATH;

typedef struct _pathnode {
	int level;
	struct _part *part;
	struct _pathnode *parent;
	LIST children;					/* list of PATHNODE */
	struct _unary *unary;
	struct _binary *binary;
} PATHNODE;

typedef struct _cluster {
	char type;
	int	 level;
	char *name;
	struct _cluster *parent;
	LIST children;					/* list of CLUSTER */
	LIST elements;					/* list of UNARY or BINARY */
	LIST pathnodes;					/* list of PATHNODE */
/* 	int npathnodes; */
/* 	struct _rule *rule; */
	int nclass;
	int *class;
	float entropy;
/* 	float weighted_entropy; */       /* entropy  weighted by proportion     */
									/* of paths in this cluster            */
/* 	float entropy_1more; */         /* sum of the entropy of children if   */
                                    /* the children were clustered with    */
	                                /* one extra cluster                   */
	struct _feature_list *cfs;		/* conditional feature space           */
	int cfs_possible;               /* -1=unknown, 0=no, 1=yes             */
	int unresolvable;            /* cluster cannot be expanded or split */
	int id;                         /* used only for save_training         */
	float *mean;                    /* mean of pts in cluster */
} CLUSTER;

typedef struct _feature_list {
	char type;
	int level;
	struct _cluster *parent;
	LIST elements;					/* list of UNARY or BINARY */
	LIST pathnodes;					/* list of PATHNODE */
/* 	int npathnodes; */
} FEATURE_LIST;

#endif /* _crgtype_ */
