/* ====================================================================
 * Comment:     External Declarations
 * ==================================================================== */

/* Global Declarations */

extern CLUSTER *cluster_tree;			/* crg cluster tree					*/
extern int      max_level;				/* max level of tree expansion		*/
extern int      nbinary_features;		/* number of binary features		*/
extern int      nclasses;				/* number of classes				*/
extern int      nunary_features;		/* number of unary features			*/
extern SCENE   *scene;					/* scene description				*/
extern int      symmetric_relations;	/* t/f binary relations symmetric	*/
extern int      classification_known;
extern LIST     part_list_training;     /* the training parts               */
extern PART   **training_parts;         /* array of training parts          */
extern int      nparts;                 /* # of training parts              */

/* Parameters */

extern char    *classification_file;	/* filename true classifications    */
extern int      runtime_max_level;      /* max level runtime tree expansion */
extern char    *scene_filename;			/* filename scene description		*/
extern char    *training_file;			/* filename training results		*/
extern int      verbosity;				/* verbosity level for messages		*/
extern int      use_intersnake_compatibility;
extern int      use_permutation_constraint;
extern int      use_relaxation_labeling;
extern int      use_single_classification_constraint;

/*
 * The leaveout flags are used for removing a particular feature from
 * the input feature spaces. This is useful for testing the performance
 * of the classifier without having to re-extract the features from scratch.
 */

extern int       nunary_leaveout, unary_leaveout[20];
extern int       nbinary_leaveout, binary_leaveout[20];

/* Mean and standard dev for features. Must transform scene values */
/* according to the zscore trans.                                  */

extern float *unary_mean, *unary_sdev;
extern float *binary_mean, *binary_sdev;

/* cutoff percentage for snakes - ie snakes must be within percentage of max snake */
extern float cutoff_snake_percentage;
extern float minimum_fuzzy_membership;

/* filenames needed for hypothesis verification */
extern char *view_file, *reg_file, *part_file;
extern IPRS_INT_IMAGE *scene_image;
extern IPRS_REGION_IMAGE *scene_regions;
