/* ========================================================================
 * SURE include
 * ======================================================================== */

#ifndef _suretype_
#define _suretype_

typedef struct _binary {
    struct _part *part1;
    struct _part *part2;
    int view;
    int class;
    float *value;
} BINARY;

typedef struct _classification {
	int level;
	struct _path *path;
	struct _cluster *cluster;
	float *cvector;
	LIST fuzzy_cfn;  /* list of fuzzy classification of ancestors */
	float fuzzy_value;
} CLASSIFICATION;

typedef struct _cluster {
	char *name;
	char type;
	int	 level;
	struct _cluster *parent;
	LIST children;					/* list of CLUSTER */
	LIST paths;						/* list of PATH */
/* 	struct _rule *rule; */
	int nclass;
	int *class;
	float *cvector;
	int id;
	int cfs_possible;
	float *mean;
} CLUSTER;

typedef struct _part {
	int name;
	int view;
	int class;
    struct _unary *unary;
    LIST binary;				/* list of BINARY */
	float *cvector;
	float *cvector1;
	int terminate_relaxation;
	LIST snakes;
	LIST touched_snakes;
	LIST modelparts;
	int modelparts_defined;
	int true_classification;
} PART;

typedef struct _path {
	int length;
    struct _part **part;
    struct _unary **unary;
    struct _binary **binary;
} PATH;

typedef struct _rule {
	int nfeatures;
	int *important;
	float *lower;
	float *upper;
} RULE;

typedef struct _scene {
	LIST parts;
	IPRS_INT_IMAGE *intensity;
	IPRS_REGION_IMAGE *regions;
} SCENE;

typedef struct _snake {
	PATH *path;
	LIST classifications;
	LIST permutations;
	LIST *modelparts;
	float compatibility;
	float *cvector;
} SNAKE;

typedef struct _unary {
    struct _part *part;
    int view;
    int class;
    float *value;
} UNARY;

typedef struct _part_num
{
	int part, view, class, num;
} PART_NUM;

#endif /* _suretype_ */
