/*****************************************************************************\
*******************************************************************************
*******                                                                 *******
*****   FILE:             bren_moments.c                                  *****
*****   AUTHOR:           brendan (mccane@coral.cs.jcu.edu.au)            *****
*****   DATE:             9/3/93                                          *****
*****   COMMENTS:         For calculating the moments of a given data set *****
*****   MODIFICATIONS:                                                    *****
*******                                                                 *******
*******************************************************************************
\*****************************************************************************/

#include "iprs.h"

float *bren_extract_moments(int num_elts, float *data, int num_moments)
{
	int i, j;
	float *moments;

	iprs_debug_enter("bren_moments");

	moments = (float *)iprs_calloc(num_moments, sizeof(float));

	for (i=0; i<num_elts; i++)
	{
		moments[0] += data[i];
	}

	moments[0] = moments[0] / num_elts;
	
	for (j=1; j<num_moments; j++)
	{
		moments[j] = 0;
		for (i=0; i<num_elts; i++)
			moments[j] += pow((data[i]-moments[0]), j+1);
		moments[j] = moments[j] / (num_elts);
	}

	iprs_debug_exit();
	return(moments);
}

int find_maxormin(int num_elts, int *data, int maxormin)
{
	int i, max;

	max = data[0];
	for (i=1; i<num_elts; i++)
		if (max*maxormin < data[i]*maxormin)
			max = data[i];
	return(max);
}
