#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

#ifndef IPRS_H
#define IPRS_H

#define LITTLE_ENDIAN

#define IPRS_FLOAT_MAX FLT_MAX
#define IPRS_NULL_IMAGE NULL

#define SQR(x) ((x)*(x))

#define IPRS_STDERR_IMAGE(a)	if(!(a)) {									\
									fprintf(stderr, "Image NULL\n"); 		\
									return;									\
								} 
#define IPRS_STDERR_IMAGEN(a)	if(!(a)) {									\
									fprintf(stderr, "Image NULL\n"); 		\
									return(NULL);							\
								} 
#define IPRS_STDERR_IMAGER(a, ret)	if(!(a)) {								\
									fprintf(stderr, "Image NULL\n"); 		\
									return(ret);							\
								} 

#define bren_in_interval(a, start, end) 						\
					(((((a)>=(start))&&((a)<=(end)))||		\
				 	(((a)>=(end))&&((a)<=(start))))?1:0)
#define bren_free(ptr, free_function) \
            {if (ptr) {free_function(ptr); ptr=NULL;}}
#define bren_sqr(x) ((x)*(x))
#define my_round(x) ((int)((x)+0.4999999))

#include "iprs_images.h"
#include "bren_images.h"
#include "iprs_fm.h"
#include "list.h"
#include "iprs.proto"

#define iprs_debug_enter(x) {}
#define iprs_debug_exit() {}
#define iprs_calloc(numels, elsize) calloc(numels, elsize)
#define iprs_malloc(size) malloc(size)
#define iprs_realloc(ptr, size) realloc(ptr, size)
#define iprs_free(ptr) free(ptr)
#define iprs_close(file) fclose(file)

/* define for parameter string functions */

#define iprs_delparam(A,B) iprs__delparam(&((A)->parameter),(B))

#define iprs_setsparam(A,B,C) iprs__setsparam(&((A)->parameter),(B),(C))
#define iprs_getsparam(A,B,C) iprs__getsparam(&((A)->parameter),(B),(C))
#define iprs_setasparam(A,B,C,D) iprs__setasparam(&((A)->parameter),(B),(C),(D))
#define iprs_getasparam(A,B,C,D) iprs__getasparam(&((A)->parameter),(B),(C),(D))
#define iprs_setall_sparam(A,B,C,D) iprs__setall_sparam(&((A)->parameter),(B),(C),(D))
#define iprs_getall_sparam(A,B,C,D) iprs__getall_sparam(&((A)->parameter),(B),(C),(D))

#define iprs_setiparam(A,B,C) iprs__setiparam(&((A)->parameter),(B),(C))
#define iprs_getiparam(A,B) iprs__getiparam(&((A)->parameter),(B))
#define iprs_setaiparam(A,B,C,D) iprs__setaiparam(&((A)->parameter),(B),(C),(D))
#define iprs_getaiparam(A,B,C) iprs__getsparam(&((A)->parameter),(B),(C))
#define iprs_setall_iparam(A,B,C,D) iprs__setall_iparam(&((A)->parameter),(B),(C),(D))
#define iprs_getall_iparam(A,B,C,D) iprs__getall_iparam(&((A)->parameter),(B),(C),(D))

#define iprs_setfparam(A,B,C) iprs__setfparam(&((A)->parameter),(B),(C))
#define iprs_getfparam(A,B) iprs__getfparam(&((A)->parameter),(B))
#define iprs_setafparam(A,B,C,D) iprs__setafparam(&((A)->parameter),(B),(C),(D))
#define iprs_getafparam(A,B,C) iprs__getafparam(&((A)->parameter),(B),(C))
#define iprs_setall_fparam(A,B,C,D) iprs__setall_fparam(&((A)->parameter),(B),(C),(D))
#define iprs_getall_fparam(A,B,C,D) iprs__getall_fparam(&((A)->parameter),(B),(C),(D))

#define iprs_seteparam(A,B,C,D) iprs__seteparam(&((A)->param),(B),(C),(D))
#define iprs_geteparam(A,B,C) iprs__geteparam(&((A)->param),(B),(C))


#endif
