#include "iprs.h"

int iprs_getheight_intimage(IPRS_INT_IMAGE *iptr)
{
	return iptr->dim[1];
}

int iprs_getwidth_intimage(IPRS_INT_IMAGE *iptr)
{
	return iptr->dim[0];
}

int iprs_getwidth_byteimage(IPRS_BYTE_IMAGE *iptr)
{
	return iptr->dim[0];
}


int iprs_getheight_floatimage(IPRS_FLOAT_IMAGE *iptr)
{
	return iptr->dim[1];
}


BREN_VECTOR *bren_region_mean(IPRS_REGION *reg)
{
	BREN_VECTOR *mean;
	float *mom, *vals;
	int i;

	vals = (float *)iprs_calloc(reg->numpixels, sizeof(float));
	mean = bren_create_vector(2);
	for (i=0; i<reg->numpixels; i++)
		vals[i] = (float)reg->x[i];
	mom = bren_extract_moments(reg->numpixels, vals, 1);
	mean->data[0] = (double)*mom;
	bren_free(mom, free);
	for (i=0; i<reg->numpixels; i++)
		vals[i] = (float)reg->y[i];
	mom = bren_extract_moments(reg->numpixels, vals, 1);
	mean->data[1] = (double)*mom;
	bren_free(mom, free);
	return(mean);
}

void iprs_set_intimage(
	IPRS_INT_IMAGE *iptr,
	int value)
{
  	int *cptr;
	int num,i;

	iprs_debug_enter("iprs_set_intimage");
	if(!iptr) {
		fprintf(stderr, "error in iprs_set_intimage\n");
		return;
    }
    if(!(iptr->image)) {
		fprintf(stderr, "error in iprs_set_intimage\n");
		return;
    }
	for(num=1,i=0;i<iptr->numdim;i++) num*=iptr->dim[i];
	cptr=iptr->image;
	for(i=0;i<num;i++) {
		*cptr=value;
		cptr++;
	}
	iprs_debug_exit();
}

