/*****************************************************************************\
*******************************************************************************
*******                                                                 *******
*****   FILE:          iprs_set_space.c                                   *****
*****   AUTHOR:        cdillon@uno.vis.citri.edu.au                       *****
*****   DATE:          05/09/91                                           *****
*****   COMMENTS:                                                         *****
*****   MODIFICATIONS:                                                    *****
*******                                                                 *******
*******************************************************************************
\*****************************************************************************/

#include "iprs.h"

void iprs_setlabel_labelspace(IPRS_LABEL_SPACE *lsptr,
							  int pnum, int num,
							  int *lptr)
{
	int i;

	iprs_debug_enter("iprs_setlabel_labelspace");
	if(!lsptr) {
		fprintf(stderr, "NULL image\n");
		return;
	}
	if(!lptr) {
		fprintf(stderr, "NULL data\n");
		return;
	}
	if((pnum<0)||(pnum>=lsptr->numpoints)) {
		fprintf(stderr, "Invalid parameter\n");
		return;
	}
	if(num) {
		while(lsptr->numlabels[pnum]) {
			iprs_rmlabel_labelspace(lsptr,pnum,lsptr->label[pnum][0]);
		}
		for(i=0;i<num;i++) {
			iprs_addlabel_labelspace(lsptr,pnum,lptr[i]);
		}
	}
	iprs_debug_exit();
}

void iprs_setpoint_featurespace(IPRS_FEATURE_SPACE *fsptr,
								int fnum,
								int pnum,
								float value)
{	
	iprs_debug_enter("iprs_setpoint_featurespace");
	if(!fsptr) {
		fprintf(stderr, "NULL image\n");
		return;
	}
	if(fnum>=fsptr->numfeatures)
		iprs_addfeature_featurespace(fsptr,fnum-fsptr->numfeatures+1);
	if(pnum>=fsptr->numpoints)
		iprs_addpoint_featurespace(fsptr,pnum-fsptr->numpoints+1);
	fsptr->point[pnum][fnum]=value;
	iprs_debug_exit();
}
